WinStd Additional templates and function helpers for Microsoft Windows using Standard C++ classes

Public Member Functions | Protected Member Functions | List of all members
winstd::reg_key Class Reference
Windows API

Registry wrapper class. More...

`#include <Win.h>`

Inheritance diagram for winstd::reg_key:

## Public Member Functions
virtual | ~reg_key ()
| Closes a handle to the registry key. More...
bool | create (_In_ HKEY hKey, _In_z_ LPCTSTR lpSubKey, _In_opt_ LPTSTR lpClass, _In_ DWORD dwOptions, _In_ REGSAM samDesired, _In_opt_ LPSECURITY_ATTRIBUTES lpSecurityAttributes=NULL, _Out_opt_ LPDWORD lpdwDisposition=NULL) noexcept
| Creates the specified registry key. If the key already exists, the function opens it. More...
bool | open (_In_ HKEY hKey, _In_opt_z_ LPCTSTR lpSubKey, _In_ DWORD ulOptions, _In_ REGSAM samDesired) noexcept
| Opens the specified registry key. More...
bool | delete_subkey (_In_z_ LPCTSTR szSubkey)
| Deletes the specified registry subkey. More...
Public Member Functions inherited from winstd::handle< HKEY, NULL >
| handle () noexcept
| Initializes a new class instance with the object handle set to INVAL.
| handle (_In_opt_ handle_type h) noexcept
| Initializes a new class instance with an already available object handle. More...
| handle (_Inout_ handle< handle_type, INVAL > &&h) noexcept
| Move constructor. More...
handle< handle_type, INVAL > & | operator= (_In_opt_ handle_type h) noexcept
| Attaches already available object handle. More...
handle< handle_type, INVAL > & | operator= (_Inout_ handle< handle_type, INVAL > &&h) noexcept
| Move assignment. More...
| operator handle_type () const
| Auto-typecasting operator. More...
handle_type *& | operator* () const
| Returns the object handle value when the object handle is a pointer to a value (class, struct, etc.). More...
handle_type * | operator& ()
| Returns the object handle reference. More...
handle_type | operator-> () const
| Provides object handle member access when the object handle is a pointer to a class or struct. More...
bool | operator! () const
| Tests if the object handle is INVAL. More...
bool | operator< (_In_opt_ handle_type h) const
| Is handle less than? More...
bool | operator<= (_In_opt_ handle_type h) const
| Is handle less than or equal to? More...
bool | operator>= (_In_opt_ handle_type h) const
| Is handle greater than or equal to? More...
bool | operator> (_In_opt_ handle_type h) const
| Is handle greater than? More...
bool | operator!= (_In_opt_ handle_type h) const
| Is handle not equal to? More...
bool | operator== (_In_opt_ handle_type h) const
| Is handle equal to? More...
void | attach (_In_opt_ handle_type h) noexcept
| Sets a new object handle for the class. More...
handle_type | detach ()
| Dismisses the object handle from this class. More...
void | free ()
| Destroys the object.

## Protected Member Functions
void | free_internal () noexcept override
| Closes a handle to the registry key. More...
virtual void | free_internal () noexcept=0
| Abstract member function that must be implemented by child classes to do the actual object destruction. More...

## Additional Inherited Members
Public Types inherited from winstd::handle< HKEY, NULL >
typedef HKEY | handle_type
| Datatype of the object handle this template class handles.
Static Public Attributes inherited from winstd::handle< HKEY, NULL >
static const HKEY | invalid
| Invalid handle value.
Protected Attributes inherited from winstd::handle< HKEY, NULL >
handle_type | m_h
| Object handle.

## Detailed Description

Registry wrapper class.

## Constructor & Destructor Documentation

## ◆ ~reg_key()

virtual winstd::reg_key::~reg_key | ( |  | ) |
| inline virtual

Closes a handle to the registry key.

See also
  RegCloseKey function

## Member Function Documentation

## ◆ create()

bool winstd::reg_key::create | ( | _In_ HKEY | hKey,
|  | _In_z_ LPCTSTR | lpSubKey,
|  | _In_opt_ LPTSTR | lpClass,
|  | _In_ DWORD | dwOptions,
|  | _In_ REGSAM | samDesired,
|  | _In_opt_ LPSECURITY_ATTRIBUTES | lpSecurityAttributes = `NULL`,
|  | _Out_opt_ LPDWORD | lpdwDisposition = `NULL`
| ) |  |
| inline noexcept

Creates the specified registry key. If the key already exists, the function opens it.

Returns
  - true when creation succeeds;
  - false when creation fails. For extended error information, call `GetLastError()`.

See also
  RegCreateKeyEx function

## ◆ delete_subkey()

bool winstd::reg_key::delete_subkey | ( | _In_z_ LPCTSTR | szSubkey | ) |
| inline

Deletes the specified registry subkey.

Parameters

  [in] | szSubkey | Name of the subkey to delete

Returns
  - true when creation succeeds;
  - false when creation fails. For extended error information, call `GetLastError()`.

## ◆ free_internal()

void winstd::reg_key::free_internal | ( |  | ) |
| inline override protected virtual noexcept

Closes a handle to the registry key.

See also
  RegCloseKey function

Implements winstd::handle< HKEY, NULL >.

## ◆ open()

bool winstd::reg_key::open | ( | _In_ HKEY | hKey,
|  | _In_opt_z_ LPCTSTR | lpSubKey,
|  | _In_ DWORD | ulOptions,
|  | _In_ REGSAM | samDesired
| ) |  |
| inline noexcept

Opens the specified registry key.

Returns
  - true when creation succeeds;
  - false when creation fails. For extended error information, call `GetLastError()`.

See also
  RegOpenKeyEx function

The documentation for this class was generated from the following file:

- include/WinStd/Win.h